// SPDX-License-Identifier: Unlicense
pragma solidity ^0.8.24;

import "./Reputation.sol";

struct Post {
    uint id;
    address sender;
    address author;
    string contentId;
    uint reputation;
    // TODO: citations
}

contract Forum is Reputation {
    mapping(uint => Post) public posts;
    uint public postCount;

    event PostAdded(uint postIndex);

    function addPost(
        address author,
        string calldata contentId
    ) external returns (uint postIndex) {
        postIndex = postCount++;
        Post storage post = posts[postIndex];
        post.author = author;
        post.sender = msg.sender;
        post.id = postIndex;
        post.contentId = contentId;
        emit PostAdded(postIndex);
    }

    function _onValidatePost(uint postIndex, uint amount) internal {
        Post storage post = posts[postIndex];
        post.reputation = amount;
        _update(address(this), post.author, amount);
    }
}
